/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.tool;

import android.content.ContentProviderOperation;
import android.content.ContentProviderResult;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.content.OperationApplicationException;
import android.database.Cursor;
import android.os.RemoteException;
import android.util.Log;

import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.CallNote;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.ui.NotesListAdapter.AppWidgetAttribute;

import java.util.ArrayList;
import java.util.HashSet;


public class DataUtils {
    // 日志标记，用于在日志中标识该类输出的信息
    public static final String TAG = "DataUtils";

    // 批量删除笔记的方法
    public static boolean batchDeleteNotes(ContentResolver resolver, HashSet<Long> ids) {
        // 如果 ids 集合为 null，打印日志并返回 true
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }
        // 如果 ids 集合大小为 0，打印日志并返回 true
        if (ids.size() == 0) {
            Log.d(TAG, "no id is in the hashset");
            return true;
        }

        // 存储操作列表的 ArrayList，用于存储要执行的删除操作
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历 ids 集合
        for (long id : ids) {
            // 不允许删除系统根文件夹
            if (id == Notes.ID_ROOT_FOLDER) {
                Log.e(TAG, "Don't delete system folder root");
                continue;
            }
            // 创建一个删除操作的构建器，并添加到操作列表中
            ContentProviderOperation.Builder builder = ContentProviderOperation
                   .newDelete(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            operationList.add(builder.build());
        }
        try {
            // 应用批量操作，并存储结果
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或结果数组长度为 0 或第一个结果为 null，打印日志并返回 false
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            return true;
        } catch (RemoteException e) {
            // 打印异常信息
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 打印异常信息
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        }
        return false;
    }

    // 将笔记移动到指定文件夹的方法
    public static void moveNoteToFoler(ContentResolver resolver, long id, long srcFolderId, long desFolderId) {
        // 创建 ContentValues 对象存储要更新的值
        ContentValues values = new ContentValues();
        // 更新目标文件夹 ID
        values.put(NoteColumns.PARENT_ID, desFolderId);
        // 存储源文件夹 ID
        values.put(NoteColumns.ORIGIN_PARENT_ID, srcFolderId);
        // 标记为本地修改
        values.put(NoteColumns.LOCAL_MODIFIED, 1);
        // 执行更新操作
        resolver.update(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id), values, null, null);
    }

    // 批量将笔记移动到指定文件夹的方法
    public static boolean batchMoveToFolder(ContentResolver resolver, HashSet<Long> ids,
            long folderId) {
        // 如果 ids 集合为 null，打印日志并返回 true
        if (ids == null) {
            Log.d(TAG, "the ids is null");
            return true;
        }

        // 存储操作列表的 ArrayList，用于存储要执行的更新操作
        ArrayList<ContentProviderOperation> operationList = new ArrayList<ContentProviderOperation>();
        // 遍历 ids 集合
        for (long id : ids) {
            // 创建一个更新操作的构建器
            ContentProviderOperation.Builder builder = ContentProviderOperation
                   .newUpdate(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, id));
            // 更新目标文件夹 ID
            builder.withValue(NoteColumns.PARENT_ID, folderId);
            // 标记为本地修改
            builder.withValue(NoteColumns.LOCAL_MODIFIED, 1);
            // 将构建好的操作添加到操作列表中
            operationList.add(builder.build());
        }

        try {
            // 应用批量操作，并存储结果
            ContentProviderResult[] results = resolver.applyBatch(Notes.AUTHORITY, operationList);
            // 如果结果为空或结果数组长度为 0 或第一个结果为 null，打印日志并返回 false
            if (results == null || results.length == 0 || results[0] == null) {
                Log.d(TAG, "delete notes failed, ids:" + ids.toString());
                return false;
            }
            return true;
        } catch (RemoteException e) {
            // 打印异常信息
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage()));
        } catch (OperationApplicationException e) {
            // 打印异常信息
            Log.e(TAG, String.format("%s: %s", e.toString(), e.getMessage());
        }
        return false;
    }

    /**
     * 获取除系统文件夹（{@link Notes#TYPE_SYSTEM}）外的所有文件夹的数量
     */
    public static int getUserFolderCount(ContentResolver resolver) {
        // 查询用户自定义文件夹的数量
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { "COUNT(*)" },
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>?",
                new String[] { String.valueOf(Notes.TYPE_FOLDER), String.valueOf(Notes.ID_TRASH_FOLER) },
                null);

        int count = 0;
        if (cursor!= null) {
            if (cursor.moveToFirst()) {
                try {
                    // 获取计数结果
                    count = cursor.getInt(0);
                } catch (IndexOutOfBoundsException e) {
                    // 打印异常信息
                    Log.e(TAG, "get folder count failed:" + e.toString());
                } finally {
                    // 关闭 Cursor 以释放资源
                    cursor.close();
                }
            }
        }
        return count;
    }

    // 检查笔记是否在笔记数据库中可见
    public static boolean visibleInNoteDatabase(ContentResolver resolver, long noteId, int type) {
        // 查询指定类型且不在回收站的笔记
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null,
                NoteColumns.TYPE + "=? AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER,
                new String[] { String.valueOf(type) },
                null);

        boolean exist = false;
        if (cursor!= null) {
            // 若结果集不为空，则表示存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
        }
        return exist;
    }

    // 检查笔记是否存在于笔记数据库中
    public static boolean existInNoteDatabase(ContentResolver resolver, long noteId) {
        // 查询指定笔记 ID 的笔记是否存在
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_NOTE_URI, noteId),
                null, null, null, null);

        boolean exist = false;
        if (cursor!= null) {
            // 若结果集不为空，则表示存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
        }
        return exist;
    }

    // 检查数据是否存在于数据数据库中
    public static boolean existInDataDatabase(ContentResolver resolver, long dataId) {
        // 查询指定数据 ID 的数据是否存在
        Cursor cursor = resolver.query(ContentUris.withAppendedId(Notes.CONTENT_DATA_URI, dataId),
                null, null, null, null);

        boolean exist = false;
        if (cursor!= null) {
            // 若结果集不为空，则表示存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
        }
        return exist;
    }

    // 检查可见文件夹名称是否存在
    public static boolean checkVisibleFolderName(ContentResolver resolver, String name) {
        // 查询具有指定名称且不在回收站的文件夹是否存在
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI, null,
                NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER +
                " AND " + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER +
                " AND " + NoteColumns.SNIPPET + "=?",
                new String[] { name }, null);
        boolean exist = false;
        if (cursor!= null) {
            // 若结果集不为空，则表示存在
            if (cursor.getCount() > 0) {
                exist = true;
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
        }
        return exist;
    }

    // 获取文件夹中的笔记小部件信息
    public static HashSet<AppWidgetAttribute> getFolderNoteWidget(ContentResolver resolver, long folderId) {
        // 查询指定文件夹中的小部件信息
        Cursor c = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { NoteColumns.WIDGET_ID, NoteColumns.WIDGET_TYPE },
                NoteColumns.PARENT_ID + "=?",
                new String[] { String.valueOf(folderId) },
                null);

        HashSet<AppWidgetAttribute> set = null;
        if (c!= null) {
            if (c.moveToFirst()) {
                set = new HashSet<AppWidgetAttribute>();
                do {
                    try {
                        // 创建并存储小部件属性对象
                        AppWidgetAttribute widget = new AppWidgetAttribute();
                        widget.widgetId = c.getInt(0);
                        widget.widgetType = c.getInt(1);
                        set.add(widget);
                    } catch (IndexOutOfBoundsException e) {
                        // 打印异常信息
                        Log.e(TAG, e.toString());
                    }
                } while (c.moveToNext());
            }
            // 关闭 Cursor 以释放资源
            c.close();
        }
        return set;
    }

    // 通过笔记 ID 获取通话号码
    public static String getCallNumberByNoteId(ContentResolver resolver, long noteId) {
        // 查询指定笔记 ID 的通话号码
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String[] { CallNote.PHONE_NUMBER },
                CallNote.NOTE_ID + "=? AND " + CallNote.MIME_TYPE + "=?",
                new String[] { String.valueOf(noteId), CallNote.CONTENT_ITEM_TYPE },
                null);

        if (cursor!= null && cursor.moveToFirst()) {
            try {
                // 获取通话号码
                return cursor.getString(0);
            } catch (IndexOutOfBoundsException e) {
                // 打印异常信息
                Log.e(TAG, "Get call number fails " + e.toString());
            } finally {
                // 关闭 Cursor 以释放资源
                cursor.close();
            }
        }
        return "";
    }

    // 通过电话号码和通话日期获取笔记 ID
    public static long getNoteIdByPhoneNumberAndCallDate(ContentResolver resolver, String phoneNumber, long callDate) {
        // 查询具有指定电话号码和通话日期的笔记 ID
        Cursor cursor = resolver.query(Notes.CONTENT_DATA_URI,
                new String[] { CallNote.NOTE_ID },
                CallNote.CALL_DATE + "=? AND " + CallNote.MIME_TYPE + "=? AND PHONE_NUMBERS_EQUAL("
                + CallNote.PHONE_NUMBER + ",?)",
                new String[] { String.valueOf(callDate), CallNote.CONTENT_ITEM_TYPE, phoneNumber },
                null);

        if (cursor!= null) {
            if (cursor.moveToFirst()) {
                try {
                    // 获取笔记 ID
                    return cursor.getLong(0);
                } catch (IndexOutOfBoundsException e) {
                    // 打印异常信息
                    Log.e(TAG, "Get call note id fails " + e.toString());
                }
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
        }
        return 0;
    }

    // 通过笔记 ID 获取片段
    public static String getSnippetById(ContentResolver resolver, long noteId) {
        // 查询指定笔记 ID 的片段
        Cursor cursor = resolver.query(Notes.CONTENT_NOTE_URI,
                new String[] { NoteColumns.SNIPPET },
                NoteColumns.ID + "=?",
                new String[] { String.valueOf(noteId) },
                null);

        if (cursor!= null) {
            String snippet = "";
            if (cursor.moveToFirst()) {
                // 获取片段
                snippet = cursor.getString(0);
            }
            // 关闭 Cursor 以释放资源
            cursor.close();
            return snippet;
        }
        // 若未找到笔记，抛出异常
        throw new IllegalArgumentException("Note is not found with id: " + noteId);
    }

    // 格式化片段
    public static String getFormattedSnippet(String snippet) {
        if (snippet!= null) {
            // 去除首尾空格
            snippet = snippet.trim();
            int index = snippet.indexOf('\n');
            if (index!= -1) {
                // 截取第一行
                snippet = snippet.substring(0, index);
            }
        }
        return snippet;
    }
}